
TCLX_HELP_PATCHES - May 27 1999

This patch file adapts the TclX8.1.x help system to provide help
about this dash-patches. It should be applied by running the
"patch" program in the top-level directory of a clean TclX8.1.x
release, using the command "patch -p0 <TCLX_HELP_PATCHES"

If you are using Solaris, don't be surprised if the patch utility
does not work. This is a known problem. Better install GNU patch
version 2.1 or later.

*** tk/help/tk/control/event.orig	Wed May  5 18:43:05 1999
--- tk/help/tk/control/event	Thu May 27 21:20:26 1999
***************
*** 45,50 ****
--- 45,52 ----
                long as it is for a window in the current  applica-
                tion.   Event  provides  a basic description of the
                event,  such  as  <Shift-Button-2>  or   <<Paste>>.
+               If  Window  is  empty  the  whole  screen is meant,
+               and  coordinates  are  relative   to  the   screen.
                Event  may  have  any  of the forms allowed for the
                sequence argument of the bind command  except  that
                it  must  consist  of a single event pattern, not a
***************
*** 228,233 ****
--- 230,241 ----
                Leave, Motion, and Property events.  Corresponds to
                the %t substitution for binding scripts.
  
+        -warp boolean
+               boolean  must  be  a  boolean  value;  it specifies
+               whether the screen  pointer  should  be  warped  as
+               well.  Valid for KeyPress, KeyRelease, ButtonPress,
+               ButtonRelease, and Motion events.
+ 
         -width size
                Size must be a screen distance;  it  specifies  the
                width  field  for  the  event.  Valid for Configure
***************
*** 263,269 ****
                lease,  ButtonPress,  ButtonRelease, Motion, Enter,
                Leave, Expose,  Configure,  Gravity,  and  Reparent
                events.  Corresponds to the the %x substitution for
!               binding scripts.
  
         -y coord
                Coord must be a screen distance;  it specifies  the
--- 271,279 ----
                lease,  ButtonPress,  ButtonRelease, Motion, Enter,
                Leave, Expose,  Configure,  Gravity,  and  Reparent
                events.  Corresponds to the the %x substitution for
!               binding scripts.  If Window is empty the coordinate
!               is  relative  to the screen, and this option corre-
!               sponds to the %X substitution for binding  scripts.
  
         -y coord
                Coord must be a screen distance;  it specifies  the
***************
*** 271,277 ****
                lease, ButtonPress, ButtonRelease,  Motion,  Enter,
                Leave,  Expose,  Configure,  Gravity,  and Reparent
                events.  Corresponds to the the %y substitution for
!               binding scripts.
  
         Any  options  that  are  not  specified when generating an
         event are filled with the  value  0,  except  for  serial,
--- 281,289 ----
                lease, ButtonPress, ButtonRelease,  Motion,  Enter,
                Leave,  Expose,  Configure,  Gravity,  and Reparent
                events.  Corresponds to the the %y substitution for
!               binding scripts.  If Window is empty the coordinate
!               is  relative  to the screen, and this option corre-
!               sponds to the %Y substitution for binding  scripts.
  
         Any  options  that  are  not  specified when generating an
         event are filled with the  value  0,  except  for  serial,
*** tk/help/tk/widgets/canvas.orig	Wed May  5 18:43:08 1999
--- tk/help/tk/widgets/canvas	Thu May 27 21:29:41 1999
***************
*** 5,15 ****
         canvas pathName ?options?
  
  STANDARD OPTIONS
!        -background     -highlightthickness            -insertwidth-takefocus
!        -borderwidth    -insertbackground              -relief-xscrollcommand
!        -cursor         -insertborderwidth             -selectbackground-yscrollcommand
!        -highlightbackground           -insertofftime  -selectborderwidth
!        -highlightcolor -insertontime  -selectforeground
  
         See  the  options manual entry for details on the standard
         options.
--- 5,15 ----
         canvas pathName ?options?
  
  STANDARD OPTIONS
!        -background          -highlightthickness -insertwidth       -state
!        -borderwidth         -insertbackground   -relief            -tile
!        -cursor              -insertborderwidth  -selectbackground  -takefocus
!        -highlightbackground -insertofftime      -selectborderwidth -xscrollcommand
!        -highlightcolor      -insertontime       -selectforeground  -yscrollcommand
  
         See  the  options manual entry for details on the standard
         options.
***************
*** 55,60 ****
--- 55,76 ----
                the coordinates may be  specified  in  any  of  the
                forms given in the COORDINATES section below.
  
+        Command-Line Name:-state
+        Database Name:  state
+        Database Class: State
+ 
+               Modifies  the  default  state  of  the canvas where
+               state may be set to one of:  normal,  disabled,  or
+               hidden.  Individual  canvas  objects all have their
+               own  state  option,  which  overrides  the  default
+               state.  Many  options  can take separate specifica-
+               tions such that the appearance of the item  can  be
+               different in different situations. The options that
+               start with "active" control the appearence when the
+               mouse pointer is over it, while the option starting
+               with "disabled" controls the  appearence  when  the
+               state is disabled.
+ 
         Command-Line Name:-width
         Database Name:  width
         Database Class: width
***************
*** 210,242 ****
  
  INDICES
         Text  items support the notion of an index for identifying
!        particular positions within the item.   Indices  are  used
!        for  commands  such as inserting text, deleting a range of
!        characters, and setting the insertion cursor position.  An
!        index  may  be  specified  in any of a number of ways, and
!        different types of items may support different  forms  for
!        specifying  indices.   Text  items  support  the following
!        forms for an index;  if you define new types of  text-like
!        items,  it  would be advisable to support as many of these
!        forms as practical.  Note that it is possible to refer  to
!        the  character  just  after the last one in the text item;
!        this is necessary for such tasks as inserting new text  at
!        the end of the item.
  
         number    A  decimal  number  giving  the  position of the
                   desired  character  within  the  text  item.   0
                   refers  to  the  first  character, 1 to the next
!                  character, and so on.  A number less than  0  is
                   treated as if it were zero, and a number greater
                   than the length of the text item is  treated  as
                   if it were equal to the length of the text item.
! 
!        end       Refers to the character just after the last  one
!                  in the item (same as the number of characters in
!                  the item).
  
         insert    Refers to the character just  before  which  the
!                  insertion cursor is drawn in this item.
  
         sel.first Refers  to  the  first selected character in the
                   item.  If the selection isn't in this item  then
--- 226,271 ----
  
  INDICES
         Text  items support the notion of an index for identifying
!        particular positions within the item.  In a similar  fash-
!        ion, line and polygon items support index for identifying,
!        inserting  and  deleting  subsets  of  their  coordinates.
!        Indices  are used for commands such as inserting or delet-
!        ing a range of characters or coordinates, and setting  the
!        insertion  cursor  position.  An index may be specified in
!        any of a number of ways, and different types of items  may
!        support  different  forms  for  specifying  indices.  Text
!        items support the following forms for an  index;   if  you
!        define new types of text-like items, it would be advisable
!        to support as many of these forms as practical.  Note that
!        it  is  possible  to refer to the character just after the
!        last one in the text item;  this  is  necessary  for  such
!        tasks as inserting new text at the end of the item.  Lines
!        and Polygons don't support the insertion  cursor  and  the
!        selection.  Their  indixes are supposed to be even always,
!        because coordinates always appear in pairs.
  
         number    A  decimal  number  giving  the  position of the
                   desired  character  within  the  text  item.   0
                   refers  to  the  first  character, 1 to the next
!                  character,  and  so  on.  If indexes are odd for
!                  lines and polygons, they will  be  automatically
!                  decremented  by  one.   A  number less than 0 is
                   treated as if it were zero, and a number greater
                   than the length of the text item is  treated  as
                   if it were equal to the length of the text item.
!                  For  polygons,  numbers  less  than 0 or greater
!                  then the length of the coordinate list  will  be
!                  adjusted  by  adding  or substracting the length
!                  until the result is between zero and the length,
!                  inclusive.
! 
!        end       Refers to the character or coordinate just after
!                  the last one in the item (same as the number  of
!                  characters or coordinates in the item).
  
         insert    Refers to the character just  before  which  the
!                  insertion cursor is  drawn  in  this  item.  Not
!                  valid for lines and polygons.
  
         sel.first Refers  to  the  first selected character in the
                   item.  If the selection isn't in this item  then
***************
*** 246,259 ****
                   item.  If the selection isn't in this item  then
                   this form is illegal.
  
!        @x,y      Refers  to the character at the point given by x
!                  and y, where x and y are specified in the  coor-
!                  dinate  system  of  the  canvas.  If x and y lie
!                  outside the  coordinates  covered  by  the  text
!                  item, then they refer to the first or last char-
!                  acter in the line that is closest to  the  given
!                  point.
! 
  
  WIDGET COMMAND
         The canvas command creates a new Tcl command whose name is
--- 275,322 ----
                   item.  If the selection isn't in this item  then
                   this form is illegal.
  
!        @x,y      Refers  to  the  character  or coordinate at the
!                  point given by x and y, where x and y are speci-
!                  fied in the coordinate system of the canvas.  If
!                  x and y lie outside the coordinates  covered  by
!                  the  text  item, then they refer to the first or
!                  last character in the line that  is  closest  to
!                  the given point.
! 
! 
! DASH PATTERNS
!        Many  items support the notion of an dash pattern for out-
!        lines.
! 
!        The first possible syntax is a list of integers. Each ele-
!        ment  represents  the  number of pixels of a line segment.
!        Only the odd segments are drawn using the "outline" color.
!        The other segments are drawn transparant.
! 
!        The  second possible syntax is a character list containing
!        only 5 possible characters [.,-_ ]. The space can be  used
!        to  enlarge the space between other line elements, and can
!        not occur as the first posibion in the string. Some  exam-
!        ples:
!            -dash .     = -dash {2 4}
!            -dash -     = -dash {6 4}
!            -dash -.    = -dash {6 4 2 4}
!            -dash -..   = -dash {6 4 2 4 2 4}
!            -dash {. }  = -dash {2 8}
!            -dash ,     = -dash {4 4}
! 
!        The  main  difference  of this syntax with the previous is
!        that it it shape-conserving. This means that all values in
!        the  dash list will be multiplied by the line width before
!        display. This assures that "." will always be displayed as
!        a  dot  and  "-"  always  as a dash regardless of the line
!        width.
! 
!        On systems where only a limited set of dash patterns,  the
!        dash pattern will be displayed as the most close dash pat-
!        tern that is available. For example, on Windows  only  the
!        first  4  of  the above examples are available. The last 2
!        examples will be displayed identically as the first one.
  
  WIDGET COMMAND
         The canvas command creates a new Tcl command whose name is
***************
*** 463,473 ****
  
         pathName dchars tagOrId first ?last?
                For each item given by tagOrId, delete the  charac-
!               ters  in  the range given by first and last, inclu-
!               sive.  If some of the items given by tagOrId  don't
!               support  text  operations,  then  they are ignored.
!               First and last are indices of characters within the
!               item(s)  as described in INDICES above.  If last is
                omitted,  it  defaults  to  first.   This   command
                returns an empty string.
  
--- 526,537 ----
  
         pathName dchars tagOrId first ?last?
                For each item given by tagOrId, delete the  charac-
!               ters, or coordinates, in the range given  by  first
!               and last, inclusive.  If some of the items given by
!               tagOrId don't support indexing operations then they
!               are ignored.  First and last are indices of charac-
!               ters  (for text) or coordinate pairs (for lines and
!               polygons) as described in INDICES above. If last is
                omitted,  it  defaults  to  first.   This   command
                returns an empty string.
  
***************
*** 483,488 ****
--- 547,553 ----
                the command.  If tagToDelete  is  omitted  then  it
                defaults to tagOrId.  This command returns an empty
                string.
+ 
         pathName find searchCommand ?arg arg ...?
                This command returns a list consisting of  all  the
                items   that  meet  the  constraints  specified  by
***************
*** 546,565 ****
                numerical  index  within  tagOrId  corresponding to
                index.  Index gives a textual  description  of  the
                desired  position  as  described  in INDICES above.
!               The return value is guaranteed to lie between 0 and
!               the  number  of  characters within the item, inclu-
!               sive.  If tagOrId refers to  multiple  items,  then
!               the  index is processed in the first of these items
!               that supports indexing operations (in display  list
!               order).
  
         pathName insert tagOrId beforeThis string
                For each of the items given by tagOrId, if the item
!               supports text insertion  then  string  is  inserted
!               into  the  item's  text  just  before the character
!               whose index is beforeThis.  See INDICES  above  for
!               information about the forms allowed for beforeThis.
!               This command returns an empty string.
  
         pathName itemcget tagOrId option
                Returns the  current  value  of  the  configuration
--- 611,638 ----
                numerical  index  within  tagOrId  corresponding to
                index.  Index gives a textual  description  of  the
                desired  position  as  described  in INDICES above.
!               Text  items interpret index as an index to a  char-
!               acter, line and polygon items interpret  it  as  an
!               index  to  a  coordinate (an x,y pair).  The return
!               value is guaranteed to lie between 0 and the number
!               of  characters,  or  coordinates,  within the item,
!               inclusive.  If tagOrId refers  to  multiple  items,
!               then  the  index is processed in the first of these
!               items that supports indexing operations (in display
!               list order).
  
         pathName insert tagOrId beforeThis string
                For each of the items given by tagOrId, if the item
!               supports text or coordinate insertion, then  string
!               is  inserted  into  the item's text just before the
!               character, or coordinate, whose  index  is  before-
!               This.   Text items interpret beforeThis as an index
!               to a  character, line and polygon  items  interpret
!               it  as an index to a coordinate (an x,y pair).  For
!               lines and polygons the string must be a valid coor-
!               dinate sequence.  See INDICES above for information
!               about the forms allowed for beforeThis.  This  com-
!               mand returns an empty string.
  
         pathName itemcget tagOrId option
                Returns the  current  value  of  the  configuration
***************
*** 751,756 ****
--- 824,830 ----
                       -pageanchor  options  to determine where the
                       printed area appears on the Postscript page.
                       Defaults to the center of the page.
+ 
                -pagey position
                       Position gives the y-coordinate of the posi-
                       tioning point on the Postscript page,  using
***************
*** 760,765 ****
--- 834,844 ----
                       printed area appears on the Postscript page.
                       Defaults to the center of the page.
  
+               -prolog boolean
+                      Boolean  specifies  whether  the  postscript
+                      output contains the prolog or not.  Defaults
+                      to yes.
+ 
                -rotate boolean
                       Boolean  specifies  whether the printed area
                       is to be rotated 90 degrees.  In non-rotated
***************
*** 804,809 ****
--- 883,889 ----
                is  determined by the raise and lower commands, not
                the raise and lower widget commands  for  canvases.
                This command returns an empty string.
+ 
         pathName scale tagOrId xOrigin yOrigin xScale yScale
                Rescale all of the items given by tagOrId in canvas
                coordinate space.  XOrigin and yOrigin identify the
***************
*** 830,847 ****
                       widget  and  x  and y are the coordinates of
                       the mouse.  It returns an empty string.
  
!               pathName scan dragto x y.
                       This command computes the difference between
                       its  x  and y arguments (which are typically
                       mouse coordinates) and the x and y arguments
                       to  the  last scan mark command for the wid-
!                      get.  It then adjusts the view by  10  times
!                      the difference in coordinates.  This command
!                      is typically associated  with  mouse  motion
!                      events  in the widget, to produce the effect
!                      of dragging the canvas at high speed through
!                      its  window.   The  return value is an empty
!                      string.
  
         pathName select option ?tagOrId arg?
                Manipulates the selection in one of  several  ways,
--- 910,927 ----
                       widget  and  x  and y are the coordinates of
                       the mouse.  It returns an empty string.
  
!               pathName scan dragto x y ?gain?.
                       This command computes the difference between
                       its  x  and y arguments (which are typically
                       mouse coordinates) and the x and y arguments
                       to  the  last scan mark command for the wid-
!                      get.  It then adjusts the view by gain times
!                      the  difference in  coordinates,  where gain
!                      defaults  to  10.  This command is typically
!                      associated  with  mouse motion events in the
!                      widget,  to  produce  the effect of dragging
!                      the canvas at high speed through its window.
!                      The return value is an empty string.
  
         pathName select option ?tagOrId arg?
                Manipulates the selection in one of  several  ways,
***************
*** 1003,1010 ****
         Most items don't support indexing or selection or the com-
         mands  related  to  them, such as index and insert.  Where
         items do support these facilities, it is noted  explicitly
!        in  the  descriptions  below  (at present, only text items
!        provide this support).
  
  
  ARC ITEMS
--- 1083,1092 ----
         Most items don't support indexing or selection or the com-
         mands  related  to  them, such as index and insert.  Where
         items do support these facilities, it is noted  explicitly
!        in  the  descriptions  below.   At present, text, line and
!        polygon items provide this support.  For lines  and  poly-
!        gons the indexing facility is used to manipulate the coor-
!        dinates of the item.
  
  
  ARC ITEMS
***************
*** 1024,1029 ****
--- 1106,1125 ----
         itemconfigure widget commands to change the item's config-
         uration.  The following options are supported for arcs:
  
+        -dash pattern
+        -activedash pattern
+        -disableddash pattern
+               This option specifies dash patterns for the  normal
+               state,  the active state, and the disabled state of
+               an arc item.  pattern may have  any  of  the  forms
+               accepted  by  Tk_GetDash.   If the dash options are
+               omitted then the default is a solid outline.
+ 
+        -dashoffset offset
+               The starting offset into the  pattern  provided  by
+               the  -dash option.  -dashoffset is ignored if there
+               is no -dash pattern.
+ 
         -extent degrees
                Specifies the size of the angular range occupied by
                the  arc.   The  arc's  range  extends  for degrees
***************
*** 1033,1059 ****
                then degrees modulo 360 is used as the extent.
  
         -fill color
!               Fill  the  region of the arc with color.  Color may
!               have any of the forms accepted by Tk_GetColor.   If
!               color  is  an empty string (the default), then then
!               the arc will not be filled.
  
         -outline color
!               Color specifies a color  to  use  for  drawing  the
!               arc's  outline;   it  may  have  any  of  the forms
!               accepted by Tk_GetColor.  This option  defaults  to
!               black.   If  color  is specified as an empty string
!               then no outline is drawn for the arc.
  
         -outlinestipple bitmap
!               Indicates that the outline for the  arc  should  be
!               drawn  with a stipple pattern; bitmap specifies the
!               stipple  pattern  to  use,  in  any  of  the  forms
!               accepted  by  Tk_GetBitmap.  If the -outline option
!               hasn't been  specified  then  this  option  has  no
!               effect.    If   bitmap  is  an  empty  string  (the
!               default), then the outline  is  drawn  in  a  solid
!               fashion.
  
         -start degrees
                Specifies  the beginning of the angular range occu-
--- 1129,1165 ----
                then degrees modulo 360 is used as the extent.
  
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies  the  color  to  be  used to fill the arc
!               region in its normal, active, and disabled  states,
!               Color may have any of the forms accepted by Tk_Get-
!               Color.  If color is an empty string (the  default),
!               then then the arc will not be filled.
  
         -outline color
!        -activeoutline color
!        -disabledoutline color
!               This option specifies the color that should be used
!               to draw the outline  of  the  arc  in  its  normal,
!               active  and disabled states.  Color may have any of
!               the forms accepted  by  Tk_GetColor.   This  option
!               defaults  to  black.   If  color is specified as an
!               empty string then no outline is drawn for the  arc.
  
         -outlinestipple bitmap
!        -activeoutlinestipple bitmap
!        -disabledoutlinestipple bitmap
!               This  option specifies stipple patterns that should
!               be used to draw the outline of the arc in its  nor-
!               mal,  active  and  disabled states.  Indicates that
!               the outline for the arc  should  be  drawn  with  a
!               stipple  pattern; bitmap specifies the stipple pat-
!               tern to use,  in  any  of  the  forms  accepted  by
!               Tk_GetBitmap.   If  the -outline option hasn't been
!               specified then  this  option  has  no  effect.   If
!               bitmap  is  an empty string (the default), then the
!               outline is drawn in a solid fashion.
  
         -start degrees
                Specifies  the beginning of the angular range occu-
***************
*** 1062,1075 ****
                3-o'clock position;  it may be either  positive  or
                negative.
  
         -stipple bitmap
!               Indicates  that the arc should be filled in a stip-
!               ple pattern; bitmap specifies the  stipple  pattern
!               to  use,  in  any  of the forms accepted by Tk_Get-
!               Bitmap.  If the -fill option hasn't been  specified
!               then  this  option  has no effect.  If bitmap is an
!               empty string (the default), then filling is done in
!               a solid fashion.
  
         -style type
                Specifies how to draw the arc.  If type is pieslice
--- 1168,1194 ----
                3-o'clock position;  it may be either  positive  or
                negative.
  
+        -state state
+               Modifies the state of the arc item where state  may
+               be  set  to one of: normal, disabled, hidden or {}.
+               If set to empty, the state of the canvas itself  is
+               used. An arc item may also be in the "active" state
+               if the mouse is currently over  it.   Many  options
+               can  take separate specifications in normal, active
+               and disabled states such that the appearance of the
+               item can be different in each state.
+ 
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This  option specifies stipple patterns that should
!               be used to fill the the arc in its  normal,  active
!               and  disabled states.  bitmap specifies the stipple
!               pattern to use, in any of  the  forms  accepted  by
!               Tk_GetBitmap.   If  the  -fill  option  hasn't been
!               specified then  this  option  has  no  effect.   If
!               bitmap is an empty string (the default), then fill-
!               ing is done in a solid fashion.
  
         -style type
                Specifies how to draw the arc.  If type is pieslice
***************
*** 1090,1102 ****
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
         -width outlineWidth
                Specifies the width of  the  outline  to  be  drawn
!               around  the  arc's  region,  in  any  of  the forms
!               described in the COORDINATES section above.  If the
!               -outline  option  has  been  specified  as an empty
!               string then this option has no effect.   Wide  out-
!               lines  will  be  drawn centered on the edges of the
                arc's region.  This option defaults to 1.0.
  
  
--- 1209,1228 ----
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time the arc item is updated on the screen.
+ 
         -width outlineWidth
+        -activewidth outlineWidth
+        -disabledwidth outlineWidth
                Specifies the width of  the  outline  to  be  drawn
!               around  the arc's region, in its normal, active and
!               disabled states.  outlineWidth may be in any of the
!               forms  described  in the COORDINATES section above.
!               If the -outline option has  been  specified  as  an
!               empty  string then this option has no effect.  Wide
!               outlines will be drawn centered on the edges of the
                arc's region.  This option defaults to 1.0.
  
  
***************
*** 1126,1148 ****
                to center.
  
         -background color
!               Specifies  a  color  to  use for each of the bitmap
!               pixels whose value is 0.  Color may have any of the
!               forms  accepted  by  Tk_GetColor.   If  this option
!               isn't specified, or if it is specified as an  empty
                string,  then nothing is displayed where the bitmap
                pixels are 0;  this produces a transparent  effect.
  
         -bitmap bitmap
!               Specifies  the  bitmap  to  display  in  the  item.
!               Bitmap may  have  any  of  the  forms  accepted  by
!               Tk_GetBitmap.
  
         -foreground color
!               Specifies  a  color  to  use for each of the bitmap
!               pixels whose value is 1.  Color may have any of the
!               forms  accepted  by  Tk_GetColor  and  defaults  to
!               black.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
--- 1252,1290 ----
                to center.
  
         -background color
!        -activebackground color
!        -disabledbackground color
!               Specifies the color to use for each of the bitmap's
!               '0'  valued  pixels  in its normal, active and dis-
!               abled states.  Color may  have  any  of  the  forms
!               accepted  by  Tk_GetColor.   If  this  option isn't
!               specified, or  if  it  is  specified  as  an  empty
                string,  then nothing is displayed where the bitmap
                pixels are 0;  this produces a transparent  effect.
  
         -bitmap bitmap
!        -activebitmap bitmap
!        -disabledbitmap bitmap
!               Specifies the bitmaps to display in the item in its
!               normal, active and  disabled  states.   Bitmap  may
!               have any of the forms accepted by Tk_GetBitmap.
  
         -foreground color
!        -activeforeground bitmap
!        -disabledforeground bitmap
!               Specifies the color to use for each of the bitmap's
!               '1'  valued  pixels  in  its  normal,  active   and
!               disabled  states.   Color may have any of the forms
!               accepted by Tk_GetColor and defaults to black.
! 
!        -state state
!               Modifies the state of the bitmap item  where  state
!               may  be set to one of: normal, disabled, or hidden.
!               An bitmap item may also be in the "active" state if
!               the  mouse  is currently over it.  Many options can
!               take separate specifications in normal, active  and
!               disabled  states  such  that  the appearance of the
!               item can be different in each state.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
***************
*** 1150,1155 ****
--- 1292,1302 ----
                replace any existing tags for  the  item.   TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time  the  bitmap  item  is  updated  on  the
+               screen.
+ 
  
  IMAGE ITEMS
         Items  of  type image are used to display images on a can-
***************
*** 1176,1184 ****
                center.
  
         -image name
!               Specifies  the  name of the image to display in the
!               item.  This image must have been created previously
!               with the image create command.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
--- 1323,1343 ----
                center.
  
         -image name
!        -activeimage name
!        -disabledimage name
!               Specifies  the name of the images to display in the
!               item in is  normal,  active  and  disabled  states.
!               This  image  must have been created previously with
!               the image create command.
! 
!        -state state
!               Modifies the state of the image  item  where  state
!               may  be set to one of: normal, disabled, or hidden.
!               An image item may also be in the "active" state  if
!               the  mouse  is currently over it.  Many options can
!               take separate specifications in normal, active  and
!               disabled  states  such  that  the appearance of the
!               item can be different in each state.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
***************
*** 1186,1195 ****
                replace  any existing tags for the item;  it may be
                an empty list.
  
  
  LINE ITEMS
         Items of type line appear on the display as  one  or  more
!        connected line segments or curves.  Lines are created with
         widget commands of the following form:
                pathName create line x1 y1... xn yn ?option value option value ...?
         The arguments x1 through yn give  the  coordinates  for  a
--- 1345,1360 ----
                replace  any existing tags for the item;  it may be
                an empty list.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time the image item is updated on the screen.
+ 
  
  LINE ITEMS
         Items of type line appear on the display as  one  or  more
!        connected line segments or  curves.   Line  items  support
!        coordinate  indexing  operations  using  the canvas widget
!        commands: dchars, index, insert.  Lines are  created  with
         widget commands of the following form:
                pathName create line x1 y1... xn yn ?option value option value ...?
         The arguments x1 through yn give  the  coordinates  for  a
***************
*** 1232,1243 ****
                then it defaults to  butt.   Where  arrowheads  are
                drawn the cap style is ignored.
  
         -fill color
!               Color  specifies  a  color  to  use for drawing the
!               line; it may have any of the  forms  acceptable  to
!               Tk_GetColor.   It  may  also be an empty string, in
!               which case the  line  will  be  transparent.   This
!               option defaults to black.
  
         -joinstyle style
                Specifies  the ways in which joints are to be drawn
--- 1397,1425 ----
                then it defaults to  butt.   Where  arrowheads  are
                drawn the cap style is ignored.
  
+        -dash pattern
+        -activedash pattern
+        -disableddash pattern
+               This option specifies dash patterns for the  normal
+               state,  the active state, and the disabled state of
+               a line item.  pattern may have  any  of  the  forms
+               accepted  by  Tk_GetDash.   If the dash options are
+               omitted then the default is a solid outline.
+ 
+        -dashoffset offset
+               The starting offset into the  pattern  provided  by
+               the  -dash option.  -dashoffset is ignored if there
+               is no -dash pattern.
+ 
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies the color to be used to fill the line  in
!               its normal, active, and disabled states.  Color may
!               have any of the forms  acceptable  to  Tk_GetColor.
!               It  may  also be an empty string, in which case the
!               line will be transparent.  This option defaults  to
!               black.
  
         -joinstyle style
                Specifies  the ways in which joints are to be drawn
***************
*** 1264,1275 ****
                ber line segments.  This option is  ignored  unless
                the -smooth option is true.
  
         -stipple bitmap
!               Indicates that the line should be filled in a stip-
!               ple pattern; bitmap specifies the  stipple  pattern
!               to  use,  in  any  of the forms accepted by Tk_Get-
!               Bitmap.   If  bitmap  is  an  empty   string   (the
!               default),  then filling is done in a solid fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
--- 1446,1469 ----
                ber line segments.  This option is  ignored  unless
                the -smooth option is true.
  
+        -state state
+               Modifies the state of the line item where state may
+               be set to one of: normal, disabled, or  hidden.   A
+               line  item may also be in the "active" state if the
+               mouse is currently over it.  Many options can  take
+               separate  specifications in normal, active and dis-
+               abled states such that the appearance of  the  item
+               can be different in each state.
+ 
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This  option specifies stipple patterns that should
!               be used to fill the the line in its normal,  active
!               and  disabled states.  bitmap specifies the stipple
!               pattern to use, in any of  the  forms  accepted  by
!               Tk_GetBitmap.   If  bitmap  is an empty string (the
!               default), then filling is done in a solid  fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
***************
*** 1277,1288 ****
                replace any existing tags for  the  item.   TagList
                may be an empty list.
  
         -width lineWidth
!               LineWidth  specifies  the width of the line, in any
!               of the forms described in the  COORDINATES  section
!               above.   Wide  lines  will be drawn centered on the
!               path specified by the points.  If this option isn't
!               specified then it defaults to 1.0.
  
  
  OVAL ITEMS
--- 1471,1489 ----
                replace any existing tags for  the  item.   TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies a Tcl command  that  is  to  be  executed
+               every  time the line item is updated on the screen.
+ 
         -width lineWidth
!        -activewidth lineWidth
!        -disabledwidth lineWidth
!               Specifies the width of  the  line  in  its  normal,
!               active  and  disabled  states.  lineWidth may be in
!               any of the forms described in the COORDINATES  sec-
!               tion  above.   Wide lines will be drawn centered on
!               the path specified by the points.  If  this  option
!               isn't specified then it defaults to 1.0.
  
  
  OVAL ITEMS
***************
*** 1303,1329 ****
         itemconfigure widget commands to change the item's config-
         uration.  The following options are supported for ovals:
  
         -fill color
!               Fill the area of the oval with  color.   Color  may
!               have  any of the forms accepted by Tk_GetColor.  If
!               color is an empty string (the default),  then  then
                the oval will not be filled.
  
         -outline color
!               Color  specifies  a  color  to  use for drawing the
!               oval's outline;  it  may  have  any  of  the  forms
!               accepted  by  Tk_GetColor.  This option defaults to
!               black.  If color is an empty string then no outline
!               will be drawn for the oval.
  
         -stipple bitmap
!               Indicates that the oval should be filled in a stip-
!               ple pattern; bitmap specifies the  stipple  pattern
!               to  use,  in  any  of the forms accepted by Tk_Get-
!               Bitmap.  If the -fill option hasn't been  specified
!               then  this  option  has no effect.  If bitmap is an
!               empty string (the default), then filling is done in
!               a solid fashion.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
--- 1504,1575 ----
         itemconfigure widget commands to change the item's config-
         uration.  The following options are supported for ovals:
  
+        -dash pattern
+        -activedash pattern
+        -disableddash pattern
+               This option specifies dash patterns for the  normal
+               state,  the active state, and the disabled state of
+               an oval item.  pattern may have any  of  the  forms
+               accepted  by  Tk_GetDash.   If the dash options are
+               omitted then the default is a solid outline.
+ 
+        -dashoffset offset
+               The starting offset into the  pattern  provided  by
+               the  -dash option.  -dashoffset is ignored if there
+               is no -dash pattern.
+ 
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies the color to be used to fill the oval  in
!               its normal, active, and disabled states.  Color may
!               have any of the forms accepted by Tk_GetColor.   If
!               color  is  an empty string (the default), then then
                the oval will not be filled.
  
         -outline color
!        -activeoutline color
!        -disabledoutline color
!               This option specifies the color that should be used
!               to  draw  the  outline  of  the oval in its normal,
!               active and disabled states.  Color may have any  of
!               the  forms  accepted  by  Tk_GetColor.  This option
!               defaults to black.  If color  is  an  empty  string
!               then no outline will be drawn for the oval.
! 
!        -outlinestipple bitmap
!        -activeoutlinestipple bitmap
!        -disabledoutlinestipple bitmap
!               This  option specifies stipple patterns that should
!               be used to draw the outline of the oval in its nor-
!               mal,  active and disabled states.  bitmap specifies
!               the stipple pattern to use, in  any  of  the  forms
!               accepted  by  Tk_GetBitmap.  If the -outline option
!               hasn't been  specified  then  this  option  has  no
!               effect.    If   bitmap  is  an  empty  string  (the
!               default), then the outline  is  drawn  in  a  solid
!               fashion.
! 
!        -state state
!               Modifies the state of the oval item where state may
!               be set to one of: normal, disabled, or hidden.   An
!               oval  item may also be in the "active" state if the
!               mouse is currently over it.  Many options can  take
!               separate  specifications in normal, active and dis-
!               abled states such that the appearance of  the  item
!               can be different in each state.
  
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This  option specifies stipple patterns that should
!               be used to fill the the oval in its normal,  active
!               and  disabled states.  bitmap specifies the stipple
!               pattern to use, in any of  the  forms  accepted  by
!               Tk_GetBitmap.   If  the  -fill  option  hasn't been
!               specified then  this  option  has  no  effect.   If
!               bitmap is an empty string (the default), then fill-
!               ing is done in a solid fashion.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
***************
*** 1331,1339 ****
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
         -width outlineWidth
!               outlineWidth specifies the width of the outline  to
!               be  drawn  around  the  oval,  in  any of the forms
                described in the COORDINATES section above.  If the
                -outline  option  hasn't  been  specified then this
                option has no effect.  Wide outlines are drawn cen-
--- 1577,1592 ----
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time the oval item is updated on the  screen.
+ 
         -width outlineWidth
!        -activewidth outlineWidth
!        -disabledwidth outlineWidth
!               Specifies  the  width  of  the  outline to be drawn
!               around the oval, in its normal, active and disabled
!               states.   outlineWidth  may  be in any of the forms
                described in the COORDINATES section above.  If the
                -outline  option  hasn't  been  specified then this
                option has no effect.  Wide outlines are drawn cen-
***************
*** 1343,1349 ****
  
  POLYGON ITEMS
         Items of type polygon appear as polygonal or curved filled
!        regions  on the display.  Polygons are created with widget
         commands of the following form:
                pathName create polygon x1 y1 ... xn yn ?option value option value ...?
         The arguments x1 through yn specify  the  coordinates  for
--- 1596,1604 ----
  
  POLYGON ITEMS
         Items of type polygon appear as polygonal or curved filled
!        regions  on the display.  Polygon items support coordinate
!        indexing operations  using  the  canvas  widget  commands:
!        dchars,  index,  insert.  Polygons are created with widget
         commands of the following form:
                pathName create polygon x1 y1 ... xn yn ?option value option value ...?
         The arguments x1 through yn specify  the  coordinates  for
***************
*** 1357,1375 ****
         change the item's configuration.   The  following  options
         are supported for polygons:
  
         -fill color
!               Color specifies a color to use for filling the area
!               of the polygon;  it  may  have  any  of  the  forms
!               acceptable  to  Tk_GetColor.   If color is an empty
!               string then the polygon will be transparent.   This
!               option defaults to black.
  
         -outline color
!               Color  specifies  a  color  to  use for drawing the
!               polygon's outline;  it may have any  of  the  forms
!               accepted  by  Tk_GetColor.   If  color  is an empty
!               string then no outline will be drawn for the  poly-
!               gon.  This option defaults to empty (no outline).
  
         -smooth boolean
                Boolean  must  have  one  of  the forms accepted by
--- 1612,1671 ----
         change the item's configuration.   The  following  options
         are supported for polygons:
  
+        -dash pattern
+        -activedash pattern
+        -disableddash pattern
+               This  option specifies dash patterns for the normal
+               state, the active state, and the disabled state  of
+               an polygon item.  pattern may have any of the forms
+               accepted by Tk_GetDash.  If the  dash  options  are
+               omitted then the default is a solid outline.
+ 
+        -dashoffset offset
+               The  starting  offset  into the pattern provided by
+               the -dash option.  -dashoffset is ignored if  there
+               is no -dash pattern.
+ 
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies  the color to be used to fill the polygon
!               in its normal, active, and disabled states.   Color
!               may  have  any  of  the forms acceptable to Tk_Get-
!               Color.  If color is an empty string then the  poly-
!               gon  will  be transparent.  This option defaults to
!               black.
! 
!        -joinstyle style
!               Specifies the ways in which joints are to be  drawn
!               at the vertices of the outline.  Style may have any
!               of the forms  accepted  by  Tk_GetCapStyle  (bevel,
!               miter,  or  round).  If this option isn't specified
!               then it defaults to round.
  
         -outline color
!        -activeoutline color
!        -disabledoutline color
!               This option specifies the color that should be used
!               to  draw  the outline of the polygon in its normal,
!               active and disabled states.  Color may have any  of
!               the  forms accepted by Tk_GetColor.  If color is an
!               empty string then no outline will be drawn for  the
!               polygon.   This  option  defaults to empty (no out-
!               line).
! 
!        -outlinestipple bitmap
!        -activeoutlinestipple bitmap
!        -disabledoutlinestipple bitmap
!               This option specifies stipple patterns that  should
!               be  used  to draw the outline of the polygon in its
!               normal, active and disabled states.  bitmap  speci-
!               fies  the  stipple  pattern  to  use, in any of the
!               forms accepted by Tk_GetBitmap.   If  the  -outline
!               option  hasn't  been specified then this option has
!               no effect.  If  bitmap  is  an  empty  string  (the
!               default),  then  the  outline  is  drawn in a solid
!               fashion.
  
         -smooth boolean
                Boolean  must  have  one  of  the forms accepted by
***************
*** 1388,1399 ****
                ber  line  segments.  This option is ignored unless
                the -smooth option is true.
  
         -stipple bitmap
!               Indicates that the polygon should be  filled  in  a
!               stipple  pattern; bitmap specifies the stipple pat-
!               tern to use,  in  any  of  the  forms  accepted  by
!               Tk_GetBitmap.   If  bitmap  is an empty string (the
!               default), then filling is done in a solid  fashion.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
--- 1684,1708 ----
                ber  line  segments.  This option is ignored unless
                the -smooth option is true.
  
+        -state state
+               Modifies  the state of the polygon item where state
+               may be set to one of: normal, disabled, or  hidden.
+               A polygon item may also be in the "active" state if
+               the mouse is currently over it.  Many  options  can
+               take  separate specifications in normal, active and
+               disabled states such that  the  appearance  of  the
+               item can be different in each state.
+ 
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This  option specifies stipple patterns that should
!               be used to fill the  the  polygon  in  its  normal,
!               active  and  disabled states.  bitmap specifies the
!               stipple  pattern  to  use,  in  any  of  the  forms
!               accepted  by  Tk_GetBitmap.   If bitmap is an empty
!               string (the default), then filling  is  done  in  a
!               solid fashion.
  
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
***************
*** 1401,1409 ****
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
         -width outlineWidth
!               OutlineWidth specifies the width of the outline  to
!               be  drawn  around  the polygon, in any of the forms
                described in the COORDINATES section above.  If the
                -outline  option  hasn't  been  specified then this
                option has no effect.  This option defaults to 1.0.
--- 1710,1726 ----
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies a Tcl command  that  is  to  be  executed
+               every  time  the  polygon  item  is  updated on the
+               screen.
+ 
         -width outlineWidth
!        -activewidth outlineWidth
!        -disabledwidth outlineWidth
!               Specifies  the  width  of the outline  drawn around
!               the polygon, in its  normal,  active  and  disabled
!               states.   outlineWidth  may  be in any of the forms
                described in the COORDINATES section above.  If the
                -outline  option  hasn't  been  specified then this
                option has no effect.  This option defaults to 1.0.
***************
*** 1436,1462 ****
         get commands to change the item's configuration.  The fol-
         lowing options are supported for rectangles:
  
         -fill color
!               Fill  the  area  of the rectangle with color, which
!               may be specified in any of the  forms  accepted  by
!               Tk_GetColor.   If  color  is  an  empty string (the
                default), then the rectangle will not be filled.
  
         -outline color
!               Draw an outline around the edge of the rectangle in
!               color.  Color may have any of the forms accepted by
!               Tk_GetColor.  This option defaults  to  black.   If
!               color  is  an  empty string then no outline will be
!               drawn for the rectangle.
  
         -stipple bitmap
!               Indicates that the rectangle should be filled in  a
!               stipple   pattern;  bitmap  specifies  the  stipple
!               pattern to use, in any of  the  forms  accepted  by
!               Tk_GetBitmap.   If  the  -fill  option  hasn't been
!               specified then  this  option  has  no  effect.   If
!               bitmap is an empty string (the default), then fill-
!               ing is done in a solid fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
--- 1753,1825 ----
         get commands to change the item's configuration.  The fol-
         lowing options are supported for rectangles:
  
+        -dash pattern
+        -activedash pattern
+        -disableddash pattern
+               This option specifies dash patterns for the  normal
+               state,  the active state, and the disabled state of
+               a rectangle item.  pattern  may  have  any  of  the
+               forms  accepted by Tk_GetDash.  If the dash options
+               are omitted then the default is a solid outline.
+ 
+        -dashoffset offset
+               The starting offset into the  pattern  provided  by
+               the  -dash option.  -dashoffset is ignored if there
+               is no -dash pattern.
+ 
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies the color to be used to fill the  rectan-
!               gle  in  its  normal,  active, and disabled states.
!               Color may be specified in any of the forms accepted
!               by  Tk_GetColor.   If color is an empty string (the
                default), then the rectangle will not be filled.
  
         -outline color
!        -activeoutline color
!        -disabledoutline color
!               This option specifies the color that should be used
!               to draw the outline of the rectangle in its normal,
!               active and disabled states.  Color may have any  of
!               the  forms  accepted  by  Tk_GetColor.  This option
!               defaults to black.  If color  is  an  empty  string
!               then no outline will be drawn for the rectangle.
! 
!        -outlinestipple bitmap
!        -activeoutlinestipple bitmap
!        -disabledoutlinestipple bitmap
!               This  option specifies stipple patterns that should
!               be used to draw the outline of the rectangle in its
!               normal,  active and disabled states.  bitmap speci-
!               fies the stipple pattern to  use,  in  any  of  the
!               forms  accepted  by  Tk_GetBitmap.  If the -outline
!               option hasn't been specified then this  option  has
!               no  effect.   If  bitmap  is  an  empty string (the
!               default), then the outline  is  drawn  in  a  solid
!               fashion.
! 
!        -state state
!               Modifies  the  state  of  the  rectangle item where
!               state may be set to one of:  normal,  disabled,  or
!               hidden.   A  rectangle  item  may  also  be  in the
!               "active" state if the mouse is currently  over  it.
!               Many  options  can  take separate specifications in
!               normal, active and disabled states  such  that  the
!               appearance  of  the  item  can be different in each
!               state.
  
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This option specifies stipple patterns that  should
!               be  used  to  fill the the rectangle in its normal,
!               active and disabled states.  bitmap  specifies  the
!               stipple  pattern  to  use,  in  any  of  the  forms
!               accepted by  Tk_GetBitmap.   If  the  -fill  option
!               hasn't  been  specified  then  this  option  has no
!               effect.   If  bitmap  is  an  empty   string   (the
!               default),  then filling is done in a solid fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
***************
*** 1464,1476 ****
                replace any existing tags for  the  item.   TagList
                may be an empty list.
  
         -width outlineWidth
!               OutlineWidth  specifies the width of the outline to
!               be drawn around the rectangle, in any of the  forms
!               described in the COORDINATES section above.  If the
!               -outline option hasn't  been  specified  then  this
!               option has no effect.  Wide outlines are drawn cen-
!               tered on the rectangular path defined  by  x1,  y1,
                x2, and y2.  This option defaults to 1.0.
  
  
--- 1827,1847 ----
                replace any existing tags for  the  item.   TagList
                may be an empty list.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time the rectangle item  is  updated  on  the
+               screen.
+ 
         -width outlineWidth
!        -activewidth outlineWidth
!        -disabledwidth outlineWidth
!               Specifies  the  width  of  the  outline to be drawn
!               around the rectangle, in  its  normal,  active  and
!               disabled states.  outlineWidth may be in any of the
!               forms described in the COORDINATES  section  above.
!               If  the  -outline option hasn't been specified then
!               this option has no effect.  Wide outlines are drawn
!               centered on the rectangular path defined by x1, y1,
                x2, and y2.  This option defaults to 1.0.
  
  
***************
*** 1504,1514 ****
                to center.
  
         -fill color
!               Color specifies a color to use for filling the text
!               characters;  it  may have any of the forms accepted
!               by Tk_GetColor.  If color is an empty  string  then
!               the text will be transparent.  If this option isn't
!               specified then it defaults to black.
  
         -font fontName
                Specifies the font to use for the text item.  Font-
--- 1875,1888 ----
                to center.
  
         -fill color
!        -activefill color
!        -disabledfill color
!               Specifies  the color to be used to fill the text in
!               its normal, active, and disabled states.  Color may
!               have  any of the forms accepted by Tk_GetColor.  If
!               color is  an  empty string  then the  text  will be
!               transparent. If this option isn't specified then it
!               defaults to black.
  
         -font fontName
                Specifies the font to use for the text item.  Font-
***************
*** 1523,1535 ****
                the text is displayed as multiple  lines.   If  the
                option is omitted, it defaults to left.
  
         -stipple bitmap
!               Indicates  that the text should be drawn in a stip-
!               pled pattern rather than  solid;  bitmap  specifies
!               the  stipple  pattern  to  use, in any of the forms
!               accepted by Tk_GetBitmap.  If bitmap  is  an  empty
!               string  (the  default)  then the text is drawn in a
!               solid fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
--- 1897,1920 ----
                the text is displayed as multiple  lines.   If  the
                option is omitted, it defaults to left.
  
+        -state state
+               Modifies the state of the text item where state may
+               be  set  to one of: normal, disabled, or hidden.  A
+               text item may also be in the "active" state if  the
+               mouse  is currently over it.  Many options can take
+               separate specifications in normal, active and  dis-
+               abled  states  such that the appearance of the item
+               can be different in each state.
+ 
         -stipple bitmap
!        -activestipple bitmap
!        -disabledstipple bitmap
!               This option specifies stipple patterns that  should
!               be  used to fill the the text in its normal, active
!               and disabled states.  bitmap specifies the  stipple
!               pattern  to  use,  in  any of the forms accepted by
!               Tk_GetBitmap.  If bitmap is an  empty  string  (the
!               default) then the text is drawn in a solid fashion.
  
         -tags tagList
                Specifies a set of  tags  to  apply  to  the  item.
***************
*** 1544,1549 ****
--- 1929,1938 ----
                changed with the insert and delete widget commands.
                This option defaults to an empty string.
  
+        -updatecommand command
+               Specifies  a  Tcl  command  that  is to be executed
+               every time the text item is updated on the  screen.
+ 
         -width lineLength
                Specifies  a  maximum  line length for the text, in
                any of the forms described in the COORDINATES  sec-
***************
*** 1589,1599 ****
--- 1978,1997 ----
                string, then the window is given whatever height it
                requests internally.
  
+        -state state
+               Modifies  the  state of the window item where state
+               may be set to one of: normal, disabled, or  hidden.
+ 
         -tags tagList
                Specifies  a  set  of  tags  to  apply to the item.
                TagList consists of a  list  of  tag  names,  which
                replace  any  existing  tags for the item.  TagList
                may be an empty list.
+ 
+        -updatecommand command
+               Specifies a Tcl command  that  is  to  be  executed
+               every  time  the  window  item  is  updated  on the
+               screen.
  
         -width pixels
                Specifies the width to assign to the item's window.
*** options.orig	Wed May  5 18:43:08 1999
--- options	Thu May 27 21:17:52 1999
***************
*** 63,68 ****
--- 63,76 ----
                active  elements.   See  above  for  definition  of
                active elements.
  
+        Command-Line Name:-activetile
+        Database Name:  activetile
+        Database Class: Tile
+ 
+               Specifies  image used to display inside active ele-
+               ments of the widget.  See above for  definition  of
+               active elements.
+ 
         Command-Line Name:-anchor
         Database Name:  anchor
         Database Class: Anchor
***************
*** 116,121 ****
--- 124,143 ----
                get.  The value may have any of the  forms  accept-
                able to Tk_GetCursor.
  
+        Command-Line Name:-dash
+        Database Name:  dash
+        Database Class: Dash
+ 
+               The  value  may  have  any of the forms accepted by
+               Tk_GetDash, such as 4, {6 4}, ., -, -., or -...
+ 
+        Command-Line Name:-dashoffset
+        Database Name:  dashoffset
+        Database Class: Dashoffset
+ 
+               Specifies the offset in the  dash  list  where  the
+               drawing starts.
+ 
         Command-Line Name:-disabledforeground
         Database Name:  disabledForeground
         Database Class: DisabledForeground
***************
*** 128,133 ****
--- 150,162 ----
                dimmed by drawing them with a  stippled  fill  pat-
                tern.
  
+        Command-Line Name:-disabledtile
+        Database Name:  disabledtile
+        Database Class: Tile
+ 
+               Specifies image to use when drawing a disabled ele-
+               ment.
+ 
         Command-Line Name:-exportselection
         Database Name:  exportSelection
         Database Class: ExportSelection
***************
*** 160,165 ****
--- 189,195 ----
         Command-Line Name:-highlightbackground
         Database Name:  highlightBackground
         Database Class: HighlightBackground
+ 
                Specifies the color to  display  in  the  traversal
                highlight  region when the widget does not have the
                input focus.
***************
*** 213,226 ****
                of the 3-D border to draw around the insertion cur-
                sor.  The value may have any of the  forms  accept-
                able to Tk_GetPixels.
         Command-Line Name:-insertofftime
         Database Name:  insertOffTime
         Database Class: OffTime
  
!               Specifies  a  non-negative integer value indicating
!               the number of  milliseconds  the  insertion  cursor
                should remain ``off'' in each blink cycle.  If this
!               option is zero then the cursor doesn't  blink:   it
                is on all the time.
  
         Command-Line Name:-insertontime
--- 243,257 ----
                of the 3-D border to draw around the insertion cur-
                sor.  The value may have any of the  forms  accept-
                able to Tk_GetPixels.
+ 
         Command-Line Name:-insertofftime
         Database Name:  insertOffTime
         Database Class: OffTime
  
!               Specifies a non-negative integer  value  indicating
!               the  number  of  milliseconds  the insertion cursor
                should remain ``off'' in each blink cycle.  If this
!               option  is  zero then the cursor doesn't blink:  it
                is on all the time.
  
         Command-Line Name:-insertontime
***************
*** 252,262 ****
                determines   when   notifications  are  made  about
                changes in the value.  The option's value must be a
                boolean of the form accepted by Tcl_GetBoolean.  If
!               the value is false, updates are  made  continuously
!               as  the  slider  is dragged.  If the value is true,
!               updates are  delayed  until  the  mouse  button  is
!               released  to  end the drag;  at that point a single
!               notification is made (the  value  ``jumps''  rather
                than changing smoothly).
  
         Command-Line Name:-justify
--- 283,293 ----
                determines   when   notifications  are  made  about
                changes in the value.  The option's value must be a
                boolean of the form accepted by Tcl_GetBoolean.  If
!               the  value  is false, updates are made continuously
!               as the slider is dragged.  If the  value  is  true,
!               updates  are  delayed  until  the  mouse  button is
!               released to end the drag;  at that point  a  single
!               notification  is  made  (the value ``jumps'' rather
                than changing smoothly).
  
         Command-Line Name:-justify
***************
*** 271,276 ****
--- 302,326 ----
                are aligned, and right means that the lines'  right
                edges line up.
  
+        Command-Line Name:-offset
+        Database Name:  offset
+        Database Class: Offset
+ 
+               Specifies the  offset  of  tiles  (see  also  -tile
+               option).  It can have two different formats -offset
+               x,y or -offset side, where side can be  n,  ne,  e,
+               se,  s, sw, w, nw, or center. In the first case the
+               origin is the origin of the toplevel of the current
+               window.   For  the canvas itself and canvas objects
+               the origin is the canvas origin, but putting  #  in
+               front  of  the  coordinate pair indicates using the
+               toplevel origin in stead. For canvas  objects,  the
+               -offset  option is used for stippling as well.  For
+               the line and polygon  canvas  items  you  can  also
+               specify  an  index  as argument, which connects the
+               stipple or tile origin to  one  of  the  coordinate
+               points of the line/polygon.
+ 
         Command-Line Name:-orient
         Database Name:  orient
         Database Class: Orient
***************
*** 320,325 ****
--- 370,376 ----
         Command-Line Name:-relief
         Database Name:  relief
         Database Class: Relief
+ 
                Specifies the 3-D effect desired  for  the  widget.
                Acceptable  values are raised, sunken, flat, ridge,
                solid, and groove.  The  value  indicates  how  the
***************
*** 452,457 ****
--- 503,516 ----
                trough areas in  widgets  such  as  scrollbars  and
                scales.
  
+        Command-Line Name:-troughtile
+        Database Name:  troughTile
+        Database Class: Tile
+ 
+               Specifies  image used to display in the rectangular
+               trough areas in  widgets  such  as  scrollbars  and
+               scales.
+ 
         Command-Line Name:-underline
         Database Name:  underline
         Database Class: Underline
***************
*** 480,486 ****
         Command-Line Name:-xscrollcommand
         Database Name:  xScrollCommand
         Database Class: ScrollCommand
- 
                Specifies   the   prefix  for  a  command  used  to
                communicate with horizontal scrollbars.   When  the
                view  in  the  widget's window changes (or whenever
--- 539,544 ----
*** tk/help/tk/widgets/text.orig	Wed May  5 18:43:09 1999
--- tk/help/tk/widgets/text	Thu May 27 21:17:52 1999
***************
*** 455,460 ****
--- 455,465 ----
                wraps, this option only applies to the last line on
                the display.
  
+        -state state
+               State  specifies  if the text  is hidden or normal.
+               Hidden  text is not displayed and takes no space on
+               screen, but further on behaves just as normal text.
+ 
         -tabs tabList
                TabList specifies a set of tab stops  in  the  same
                form  as  for the -tabs option for the text widget.
***************
*** 1120,1125 ****
--- 1125,1134 ----
                       of a variable; if a match is found, the num-
                       ber of characters in the matching range will
                       be stored in the variable.
+ 
+               -hidden
+                      Find  hidden  text  as well. By default only
+                      displayed text is found.
  
                --     This  switch  has no effect except to termi-
                       nate the list of switches: the next argument
